> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/vm/virtual-machine-instance/describeinstances.md).

# DescribeInstances

## 1. API Description

This API (DescribeInstances) is used to query the details of instances. You can filter the query results with the instance ID, name, or billing method.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name     | Required | Type                                                                                  | Description                                                                                                                                         |
| ------------------ | -------- | ------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceIds        | No       | Array of String                                                                       | <p>Instance IDs.</p><p>You can query up to 100 instances in each request.</p>                                                                       |
| zoneId             | No       | String                                                                                | Zone ID to which the instances belong.                                                                                                              |
| internetChargeType | No       | [InternetChargeType](/api-reference/compute/vm/datastructure.md#internetchargetype)   | <p>Network pricing model.</p><p>See</p><p>InternetChargeType for details.</p>                                                                       |
| imageId            | No       | String                                                                                | Image ID.                                                                                                                                           |
| instanceType       | No       | String                                                                                | <p>Instance model ID.</p><p>You can call DescribeInstanceTypes to obtain the latest specification.</p>                                              |
| keyId              | No       | String                                                                                | <p>SSH key pair ID.</p><p>For example: key-YWD2QFOl .</p>                                                                                           |
| publicIpAddresses  | No       | Array of String                                                                       | Public IPv4 addresses.                                                                                                                              |
| privateIpAddresses | No       | Array of String                                                                       | Public IPv4 addresses in subnet.                                                                                                                    |
| instanceStatus     | No       | [InstanceStatusValue](/api-reference/compute/vm/datastructure.md#instancestatusvalue) | <p>Instance status.</p><p>See InstanceStatus for details.</p>                                                                                       |
| instanceName       | No       | String                                                                                | <p>Instance name.</p><p>If the value ends with \*, a fuzzy match will be performed on instanceName, otherwise an exact match will be performed.</p> |
| subnetId           | No       | String                                                                                | <p>Subnet ID.</p><p>You can call DescribeSubnets to query information on subnet.</p>                                                                |
| securityGroupId    | No       | String                                                                                | Security group ID.                                                                                                                                  |
| pageSize           | No       | Integer                                                                               | <p>Number of items in the current page result.</p><p>Default value: 20;</p><p>Maximum value: 1000.</p>                                              |
| pageNum            | No       | Integer                                                                               | <p>Number of pages returned.</p><p>Default value: 1.</p><p>Default value: 1</p>                                                                     |
| resourceGroupId    | No       | String                                                                                | <p>Resource group ID.</p><p>If the value is null, then return all the instances in the authorized resource groups.</p>                              |
| tagKeys            | No       | Array of String                                                                       | <p>Query using tag keys.</p><p>A maximum of 20 tag keys can be used.</p>                                                                            |
| tags               | No       | Array of [Tag](/api-reference/compute/vm/datastructure.md#tag)                        | <p>Query using tags.</p><p>A maximum of 20 tags can be used.</p>                                                                                    |

## 3. Output Parameters

| Parameter Name | Type                                                                             | Description                                                                                                           |
| -------------- | -------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                           | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                          | Number of instances meeting the filtering conditions.                                                                 |
| dataSet        | Array of [InstanceInfo](/api-reference/compute/vm/datastructure.md#instanceinfo) | Information on an instance.                                                                                           |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query list of virtual machine instances.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeInstances
<Common Request Params>

Request:
{
  "pageNum": 1,
  "pageSize": 1
}

Response:
{
    "requestId":"T4E7FED5D-4A69-4B4B-AF57-BCD20BDC053A",
    "response":{
        "requestId":"T4E7FED5D-4A69-4B4B-AF57-BCD20BDC053A",
        "dataSet":[
            {
                "instanceId":"instanceIdxxxxx",
                "zoneId":"SAO-A",
                "instanceName":"Ubuntu-1c2g-web",
                "instanceType":"c.1c2g",
                "autoRenew":true,
                "cpuCount":1,
                "memory":2,
                "imageId":"img-prEjRbTonNiUyuhSrLrJB2gTk",
                "imageName":"Ubuntu-20.04",
                "instanceChargeType":"PREPAID",
                "internetMaxBandwidthOut":1,
                "internetChargeType":"ByBandwidth",
                "period":1,
                "publicIpAddresses":[
                    "128.1.1.1"
                ],
                "privateIpAddresses":[
                    "10.0.1.0"
                ],
                "subnetId":"your-subnet-id",
                "createTime":"2023-03-01T00:00:00Z",
                "expiredTime":"2023-03-31T00:00:00Z",
                "resourceGroupId":"default-resource-group-id",
                "resourceGroupName":"Default Resource Group",
                "instanceStatus":"RUNNING",
                "securityGroupIds":[
                    "843869472514124338"
                ],
                "systemDisk":{
                    "diskId":"your disk id",
                    "diskSize":30
                }
            }
        ],
        "totalCount":1
    }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
